function gabor_control_v01(input_filename)


output_filename = [input_filename(1:length(input_filename)-4) '.out'];

%make sure outputfilelist is empty

delete(output_filename);

%%read all color.png images from DIR

filenames=textread(input_filename,'%s');

numFile = numel(filenames);

outputfile = fopen(output_filename,'a'); 

disp('Total number of images read:');

fprintf('%d\n',numFile);

for iFile=1:numFile
    
  featurefile = fopen([filenames{iFile}(1:18) '.g0805'],'a'); 

  %%Gabor feature extraction
    
  origOut = gabor_filter_v01(filenames{iFile});  
  
  resizeOut = reshape(origOut,[1, size(origOut,1)*size(origOut,2)]);
  

  fprintf(featurefile, '%d ',uint8(resizeOut));
  
  fprintf(featurefile, '\n');
  
  
  fprintf(outputfile, '%s',[filenames{iFile}(1:18) '.g0805']);
  
  fprintf(outputfile, '\n');
  
end


disp('Total number of images processed:');

fprintf('%d\n',iFile);

fclose('all');
