%The Gabor filter is basically a Gaussian (with variances xcoviarance and ycoviarance along x and y-axes respectively)

%modulated by a complex sinusoid (with centre frequencies U and V along x and y-axes respectively) 

%described by the following equation
%%
%                            -1     x' ^     y'  ^             
%%% G(x,y,theta,f) =  exp ([----{(----) 2+(----) 2}])*cos(2*pi*f*x');
%                             2    xcoviarance'       ycoviarance'
%%% x' = x*cos(theta)+y*sin(theta);
%%% y' = y*cos(theta)-x*sin(theta);

%%filename is the input image for feature extraction

%%J is resized image from original input image with size [80 70]

%%We have 8 orientations for the gabor filter; 

%%xcoviarance is always equal to ycoviarance, which is equal to 2*pi. They are the coriarance of the Gaussian distribution; 

%%vi is the scales of the filters, start from 0 to 4.

function meanout = gabor_filter_v01(filename)

recipe_gabor_v01();

I = rgb2gray(imread(filename));

J = imresize(I,newsize);

xcoviarance = coviarance;

ycoviarance = xcoviarance;

for vi = 1:length(scales)
    
    for j = 1:length(orientation)
        
      %save output filtered images to gbout
      
      f = 2^((-vi+1)/2*pi);
      
      theta = orientation(j)*pi/180;
      
      %to make sure the image is double precision

      if isa(J,'double')~=1 
         
         J = double(J);
        
      end
      
      %calculate Gabor filter

       for x = -fix(xcoviarance):fix(xcoviarance)
           
          for y = -fix(ycoviarance):fix(ycoviarance)
              
             xPrime = x * cos(theta) + y * sin(theta);
             
             yPrime = y * cos(theta) - x * sin(theta);
             
             G(fix(xcoviarance)+x+1,fix(ycoviarance)+y+1) = exp(-.5*((xPrime/xcoviarance)^2+(yPrime/ycoviarance)^2))*cos(2*pi*f*xPrime);
          end
          
       end

       Imgabout = conv2(J,double(imag(G)),'same');
       
       Regabout = conv2(J,double(real(G)),'same');
       
       %calculate the magnitude of the gabor filtered image

       gabout = sqrt(Imgabout.*Imgabout + Regabout.*Regabout);
      
       Filter(:,:,(vi-1)*j+j) = G;
       
       out(:,:,(vi-1)*j+j) = gabout;
      
       %%resacle filtered images to [0,255]
      
       out(:,:,(vi-1)*j+j) = out(:,:,(vi-1)*j+j).*intensity/(max(max(out(:,:,(vi-1)*j+j)))-min(min(out(:,:,(vi-1)*j+j))));
      
    end
    
end

meanout = mean(out,3);

%imshow(uint8(gbout_mean));