% file: /home/tuc74165/isip/exp/asl_reco/gaborfeature/exp_000
% description: Gabor filters are similar to those of the human visual system, 
% and they have been found to be particularly appropriate for texture representation
% and discrimination. In the spatial domain, a 2D Gabor filter is a Gaussian kernel 
% function modulated by a sinusoidal plane wave. Details for the implementation of
% Gabor filter can be found at:

% Mohsin, S., Javed, M., & Anjum, A. (2006). Face Recognition using Bank of Gabor Filters. 
% Emerging Technologies 2006 ICET06 International Conference on, (November), 144-150. 

% parameters: resize,orientations, coviariances, scales

% this parameter resizes the image (explain)
newsize = [40 30];

% this parameter define the orientations of the Gabor filter
orientation = [0,30,45,60,90,120,135,150];

% this parameter define the coviariances of the Gaussian kernal    
coviarance = 2*pi;

% this parameter define the scales for Gabor filter 
scales = [0,1,2,3,4];

%define rescale intensity;
intensity=255;
%end of configuration


